#
# spec file for package microsoft-hyper-v
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.
#
#

# nodebuginfo
# norootforbuild
# needssslcertforbuild

%define MODULES hv_vmbus hv_storvsc
%define releasetag public
%define release %(date +%%Y%%m%%d)
%define _unpackaged_files_terminate_build 0
%define rdma_dir July-04-2015
Name:			msft-lis-rdma

BuildRequires:          %kernel_module_package_buildreqs
Requires:               microsoft-hyper-v-kmod = 4.0.10
License:		GPL-2.0
Group:			System/Kernel
Summary:		Microsoft Linux Integration Services with Infiniband RDMA Driver
Version:		20150707.140.0
Release:		1.1
Source0:		hv-sles12.tar.gz	
Source1:		%{rdma_dir}.tar
Source2:                drivers.infiniband.hw.mlx4.user.h
Patch0:			hv_vmbus-version-tag.patch
Patch1:                 provider.c.patch
Patch2:                 vmbus_rdma.c.patch
BuildRoot:		%{_tmppath}/%{name}-%{version}-build

%kernel_module_package -x xen

%description
This package contains the Microsoft Linux Integration Services with hv_network_direct RDMA driver for SLES 12.

%prep
%setup -n hv -a 1
%patch0 -p1
pushd %{rdma_dir}
%patch1 -p0
%patch2 -p0
mv -vt .. \
	mx_abi.h \
	provider.c \
	hvnd_addr.c \
	vmbus_rdma.h \
	vmbus_rdma.c
popd
rm -rf %{rdma_dir}
#
if grep -wn reinit_completion /usr/src/linux/include/linux/completion.h
then
	sed -i~ '
	/^static inline void reinit_completion/ {
	N
	N
	N
	d
	}
	' hv_balloon.c
	diff -u hv_balloon.c~ hv_balloon.c || true
fi
#
cp %{S:2} user.h
sed -i~ 's^@TAG@^%{name}-%{version}-%{release} built in %{distribution}^' vmbus_drv.c
diff -u vmbus_drv.c~ vmbus_drv.c || true
cat >> Makefile <<EOF
obj-m += hv_network_direct.o
hv_network_direct-y := provider.o vmbus_rdma.o hvnd_addr.o
EOF
upstream="`cat /usr/src/linux/include/rdma/ib_umem.h | sed -n '/^struct ib_umem {/,/};/s@struct sg_table sg_head@&@p'`"
if test -n "${upstream}"
then
	echo "CFLAGS_vmbus_rdma.o += -Dstruct_ib_mem_sg_head" >> Makefile
	echo "CFLAGS_provider.o += -Dstruct_ib_mem_sg_head" >> Makefile
fi
#
cat > Module.supported <<EOF
hid-hyperv.ko external
hv_balloon.ko external
hv_netvsc.ko external
hv_storvsc.ko external
hv_utils.ko external
hv_vmbus.ko external
hyperv-keyboard.ko external
hyperv_fb.ko external
hv_network_direct.ko external
EOF
#
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
for flavor in %flavors_to_build; do
        rm -rf obj/$flavor
        cp -r source obj/$flavor
        make -C %{kernel_source $flavor} M=$PWD/obj/$flavor modules
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
        make -C %{kernel_source $flavor} M=$PWD/obj/$flavor modules_install
done
